; File Name   :	bert.bin
; Format      :	Binary file
; Base Address:	0000h Range: 1000h - 2000h Loaded length: 1000h

; System-EPROM f. Basic-Einplatinen-Rechner 'BERT'
; Version 2.0 (c) Dr. Bernd Schul 1987

; reass: Volker Pohlers 27.06.2012, letzt nderung 28.06.2012

;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255

		cpu	z8601


; Funktionen aus BASIC/DEBUG
unk_E 	equ 000Eh
unk_2B 	equ 002Bh
getc 	equ 0054h			; Zeichen empfangen
putc 	equ 0061h			; Zeichen ausgeben

; Ports
p0 equ	0				; Port 0
p1 equ	1				; Port 1
p2 equ	2				; Port 2
p3 equ	3				; Port 3

; spez. Register
sio equ 0F0h				; Serial I/O
tmr equ 0F1h				; Timer	mode
t1 equ	0F2h				; Timer/counter	1
pre1 equ 0F3h				; T1 prescaler
t0 equ	0F4h				; Timer/counter	0
pre0 equ 0F5h				; T0 prescaler
p2m equ 0F6h				; Port 2 mode
p3m equ 0F7h				; Port 3 mode
p01m equ 0F8h				; Ports	0-1 mode
ipr equ 0F9h				; Interrupt priority register
irq equ 0FAh				; Interrupt request register
imr equ 0FBh				; Interrupt mask register
flags equ 0FCh				; Program control flags
rp equ	0FDh				; Register pointer
gpr equ 0FEh				; General purpose register
spl equ 0FFh				; Stack	pointer



;==============================================================================
; Sprungvektoren
;==============================================================================

		org	1000h

;irq 0
		jp	irqret
;irq 1
		jp	irqret
;irq 2
		jp	loc_1EF0
;irq 3
		jp	irqret
;irq 4
		jp	irqret
;irq 5
		jp	loc_1BB4
;ext. Zeicheneingabe
		jp	getc		; Zeichen empfangen
;ext. Zeichenausgabe
		jp	putc		; Zeichen ausgeben
;Kommandomodus
		jp	loc_1B63
;Speicherinhalt listen
		jp	loc_17C7



;==============================================================================
; Autostart
;==============================================================================

		org	1020h
;Autostart
		db 0FFh			; ab hier kann ein BASIC-Pgm. stehen
		db 0FFh



;==============================================================================
; EPROM-Programmierer
;==============================================================================

		org	153Fh

; Patch zu kdo_set
sub_153F:	push	R14
		call	2BFh
		pop	R14
		ret

; Patch zu kdo_get
sub_1547:	push	R14
		call	4E6h
		pop	R14
		ret

;???
x_154F		clr	R4
		clr	R5
		clr	R3
		ld	R0, #8
		clr	R1
loc_1559:	ldc	R2, @RR4
		add	R3, R2
		incw	RR4
		cp	R4, R0
		jr	NZ, loc_1559
		cp	R5, R1
		jr	NZ, loc_1559
		ld	R4, #10h
		clr	R5
		ld	R0, #20h
		clr	R1
loc_156F:	ldc	R2, @RR4
		add	R3, R2
		incw	RR4
		cp	R4, R0
		jr	NZ, loc_156F
		cp	R5, R1
		jr	NZ, loc_156F
		clr	R2
		ret

;-----------------------------------------
;EPROM brennen
;-----------------------------------------

loc_1580:	call	sub_1736
		jr	C, locret_15FF
		call	loc_1612
		jr	C, locret_15FF
		clr	36h
		ld	37h, #1
		ld	38h, #7Fh
		ld	39h, #0FFh
		clr	3Ah
		ld	3Bh, #20h

;-----------------------------------------
;BASIC/DEBUG-Programm in EPROM bertragen
;von Zeilennummer in %36,%37 bis Zeilennummer in %38,%39
;in %3A,%3B steht die relative Anf.adr im EPROM
;-----------------------------------------

loc_159A:	push	R6
		push	R7
		push	R8
		push	R9
		push	R10
		push	R11
		push	R14
		ld	R4, 36h
		ld	R5, 37h
		call	34Fh
		decw	RR10
		decw	RR10
		ld	36h, R10
		ld	37h, R11
		ld	R4, 38h
		ld	R5, 39h
		incw	RR4
		call	34Fh
		decw	RR10
		decw	RR10
		ld	38h, R10
		ld	39h, R11
		ld	R0, 3Ah
		ld	R1, 3Bh
		add	R1, 39h
		adc	R0, 38h
		sub	R1, 37h
		sbc	R0, 36h
		cp	R0, #0Bh
		jr	GT, loc_15E9
		jr	LT, loc_15E4
		cp	R1, #57h
		jr	GE, loc_15E9

loc_15E4:	call	sub_163B
		jr	loc_15F1

loc_15E9:	ld	R8, #hi(aProgrammZuGros)
		ld	R9, #lo(aProgrammZuGros)
		call	556h
		scf

loc_15F1:	pop	R14
		pop	R11
		pop	R10
		pop	R9
		pop	R8
		pop	R7
		pop	R6

locret_15FF:	ret

aProgrammZuGros:db "PROGRAMM ZU GROSS"
		db  8Dh ; 

;-----------------------------------------
;EPROM formatieren
;-----------------------------------------


loc_1612:	ld	36h, #10h
		clr	37h
		ld	38h, #10h
		ld	39h, #1Eh
		clr	3Ah
		clr	3Bh
		call	sub_163B
		jr	C, locret_163A
		ld	36h, #1Bh
		ld	37h, #57h
		ld	38h, #20h
		clr	39h
		ld	3Ah, #0Bh
		ld	3Bh, #57h
		call	sub_163B
locret_163A:	ret

;-----------------------------------------
;Datenbereich in EPROM bertragen
;%36,%37	Anfadr.
;%38,%39	Endadr+1
;%3A,%3B	relative Anfadr. im EPROM
;-----------------------------------------

sub_163B:	push	R8
		push	R9
		push	R6
		ld	>p3, #10h	; Port 3
		clr	p2m		; Port 2 mode
		ld	R4, #60h
		ld	R1, 39h
		ld	R0, 38h
		sub	R1, 37h
		sbc	R0, 36h
		decw	RR0
		jr	LT, loc_1691
		cp	R0, #10h
		jr	GE, loc_1691
		ld	R0, 36h
		ld	R1, 37h
		ld	R2, 3Ah
		ld	R3, 3Bh
loc_1663:	call	sub_1786
		ldc	R5, @RR0
		ld	>p2, R5		; Port 2
		ld	R6, #5
		ld	pre1, #2	; T1 prescaler
		ld	t1, #90h	; Timer/counter	1
loc_1672:	ld	tmr, #8Eh	; Timer	mode
loc_1675:	ld	R5, t1		; Timer/counter	1
		inc	R5
		djnz	R5, loc_1675
		djnz	R6, loc_1672
		incw	RR0
		incw	RR2
		cp	R0, 38h
		jr	NZ, loc_1663
		cp	R1, 39h
		jr	NZ, loc_1663
		ld	tmr, #2		; Timer	mode
		pop	R6
		jr	loc_16B5
loc_1691:	ld	R8, #hi(aFalscheParamet)
		ld	R9, #lo(aFalscheParamet)
		call	556h
		pop	R6
		pop	R9
		pop	R8
		ret

aFalscheParamet:db "FALSCHE PARAMETER"
		db  8Dh ; 


;-----------------------------------------
;EPROM mit RAM vergleichen
;%36,%37	Anfadr.	RAM-Bereich
;%38,%39	Endadr+1 RAM-Bereich
;%3A,%3B	relative Anfadr. im EPROM
;-----------------------------------------


loc_16B1:	push	R8
		push	R9
loc_16B5:	push	R14
		ld	>p3, #0		; Port 3
		ld	p2m, #0FFh	; Port 2 mode
		ld	R4, #60h
		ld	R0, 36h
		ld	R1, 37h
		ld	R2, 3Ah
		ld	R3, 3Bh
loc_16C7:	call	sub_1786
		call	sub_1791
		ldc	R14, @RR0
		cp	R14, R5
		jr	NZ, loc_16EA
		incw	RR0
		incw	RR2
		cp	R0, 38h
		jr	NZ, loc_16C7
		cp	R1, 39h
		jr	NZ, loc_16C7
		ld	R8, #hi(aEpromOk)
		ld	R9, #lo(aEpromOk)
		call	556h
		jr	loc_16F2
loc_16EA:	ld	R8, #hi(aEpromFehler)
		ld	R9, #lo(aEpromFehler)
		call	556h
		scf

loc_16F2:	pop	R14
		pop	R9
		pop	R8
		ret

aEpromOk:	db "EPROM OK"
		db  8Dh ; 
aEpromFehler:	db "EPROM FEHLER"
		db  8Dh ; 


;-----------------------------------------
;EPROM in RAM in bertragen
;%36,%37	Anfadr.	RAM-Bereich
;%38,%39	Endadr+1 RAM-Bereich
;%3A,%3B	relative Anfadr. im EPROM
;-----------------------------------------

loc_170F:	ld	>p3, #0		; Port 3
		ld	p2m, #0FFh	; Port 2 mode
		ld	R4, #60h
		ld	R0, 36h
		ld	R1, 37h
		ld	R2, 3Ah
		ld	R3, 3Bh
loc_171F:	call	sub_1786
		call	sub_1791
		ldc	@RR0, R5
		incw	RR0
		incw	RR2
		cp	R0, 38h
		jr	NZ, loc_171F
		cp	R1, 39h
		jr	NZ, loc_171F
		ret

;-----------------------------------------
;EPROM Leertest
;-----------------------------------------

sub_1736:	ld	38h, #10h
		clr	39h
		clr	3Ah
		clr	3Bh
		ld	>p3, #0		; Port 3
		ld	p2m, #0FFh	; Port 2 mode
		ld	R4, #60h
		ld	R2, 3Ah
		ld	R3, 3Bh
		push	R8
		push	R9
loc_174F:	call	sub_1786
		call	sub_1791
		cp	R5, #-1
		jr	NZ, loc_1768
		incw	RR2
		cp	R2, 38h
		jr	NZ, loc_174F
		cp	R3, 39h
		jr	NZ, loc_174F
		jr	loc_1770
loc_1768:	ld	R8, #hi(aEpromNichtLeer)
		ld	R9, #lo(aEpromNichtLeer)
		call	556h
		scf
loc_1770:	pop	R9
		pop	R8
		ret

aEpromNichtLeer:db "EPROM NICHT LEER"
		db  8Dh ; 

;-----------------------------------------
; EPROM-UPs

sub_1786:	ldc	@RR4, R2
		or	>p3, #20h	; Port 3
		and	>p3, #0DFh	; Port 3
		ldc	@RR4, R3
		ret


sub_1791:	and	>p3, #0EFh	; Port 3
		or	>p3, #40h	; Port 3
		ld	R5, #10h
loc_1799:	djnz	R5, loc_1799
		ld	R5, >p2		; Port 2
		and	>p3, #0BFh	; Port 3
		ret


;-----------------------------------------
; Copyright, Sprungverteiler f. EPROMMER
;-----------------------------------------


		db "(C)SCHULE1987"

;EPROM Leertest
		jp	sub_1736
;EPROM mit RAM vergleichen
		jp	loc_16B1
;EPROM in RAM in bertragen
		jp	loc_170F
;Daten in EPROM bertragen
		jp	sub_163B
;BASIC/DEBUG-Programm in EPROM bertragen
		jp	loc_159A
;EPROM formatieren
		jp	loc_1612
;EPROM brennen
		jp	loc_1580



;=========================================
; Z8-Register anzeigen und ndern
; GO@17C3,anfadr,endadr+1
;=========================================

		clr	R1
		jr	loc_17C9

;=========================================
; Speicher-Inhalte anzeigen
; Anzeige hexadezimal und Ascii
; GO@%101B,anfadr,endadr+1
;=========================================

loc_17C7:	ld	R1, #1
loc_17C9:	push	R15
		push	R10
		push	R11
		call	38Dh
loc_17D2:	ld	R2, R4
		ld	R3, R5
		call	26Eh
		inc	R15
		call	530h
		ld	R0, #8
loc_17DF:	ld	R3, #20h
		call	putc		; Zeichen ausgeben
		call	loc_1827
		call	545h
		call	loc_1827
		incw	RR4
		call	544h
		djnz	R0, loc_17DF
		ld	R0, #8
loc_17F6:	decw	RR4
		djnz	R0, loc_17F6
		ld	R3, #20h
		call	putc		; Zeichen ausgeben
		ld	R0, #8
loc_1801:	call	loc_1827
		and	R3, #7Fh
		cp	R3, #20h
		jr	GE, loc_180E
		ld	R3, #2Eh
loc_180E:	call	putc		; Zeichen ausgeben
		incw	RR4
		djnz	R0, loc_1801
		call	unk_2B
		cp	R4, R10
		jr	NZ, loc_17D2
		cp	R5, R11
		jr	C, loc_17D2
		pop	R11
		pop	R10
		pop	R15
		ret
;
loc_1827:	inc	R1
		djnz	R1, loc_182D
		ld	R3, @R5
		db  0Dh			; JP FALSE,.. -> nachfolgenden Befehl bergehen
loc_182D:	ldc	R3, @RR4
		ret


;=========================================
; RAM-Inhalte ndern
; GO@%1830,anfadr
;=========================================

loc_1830	push	R15
		push	R10
		push	R11
loc_1836:	call	unk_2B
		ld	R2, R4
		ld	R3, R5
		call	26Eh
		inc	R15
		call	530h
		ld	R3, #3Ah	; ':'
		call	putc		; Zeichen ausgeben
		call	getc		; Zeichen empfangen
		cp	R3, #0Dh	; ENTER?
		jr	Z, loc_1870
		ld	21h, R3
		call	getc		; Zeichen empfangen
		ld	22h, R3
		ld	23h, #2Ch	; ','
		ld	R11, #21h
		clr	R10
		call	2F8h
		cp	R3, #2Ch
		jr	NZ, loc_1836
		call	unk_E
		ldc	@RR4, R3
		incw	RR4
		jr	loc_1836
loc_1870:	pop	R11
		pop	R10
		pop	R15
		ret

		db 0FFh

;==============================================================================
; Monitor-Programm
;==============================================================================

;Kommandotabelle, s.S. 206
;1. Byte mit gesetztem 7. Bit
;Kommandoname, Ende mit = oder ?
;Kommandoadr, als 2 x 7 Bit abgelegt (adr shr 7, adr and %7F)


kdo		macro	kdoname, kdoadr
		db	charfromstr(kdoname, 0) | 80h
		db	substr(kdoname, 1, 0)
		db	(kdoadr) >> 7, (kdoadr) & 7fh
name		set	kdoname		
adr		set	kdoadr
		shared	name, adr
		endm

kdotab:		; Portein/ausgabe
		kdo "A=", kdo_aset
		kdo "B=", kdo_bset
		kdo "D=", kdo_dset
		kdo "G=", kdo_gset

		kdo "A?", kdo_aget
		kdo "B?", kdo_bget
		kdo "C?", kdo_cget
		kdo "E?", kdo_eget

		kdo "A0=", kdo_a0set
		kdo "A1=", kdo_a1set
		kdo "A2=", kdo_a2set
		kdo "A3=", kdo_a3set
		kdo "A4=", kdo_a4set
		kdo "A5=", kdo_a5set
		kdo "A6=", kdo_a6set
		kdo "A7=", kdo_a7set

		kdo "B4=", kdo_b4set
		kdo "B5=", kdo_b5set
		kdo "B6=", kdo_b6set

		kdo "D0=", kdo_d0set
		kdo "D1=", kdo_d1set
		kdo "D2=", kdo_d2set
		kdo "D3=", kdo_d3set
		kdo "D4=", kdo_d4set
		kdo "D5=", kdo_d5set
		kdo "D6=", kdo_d6set
		kdo "D7=", kdo_d7set

		kdo "A0?", kdo_a0get
		kdo "A1?", kdo_a1get
		kdo "A2?", kdo_a2get
		kdo "A3?", kdo_a3get
		kdo "A4?", kdo_a4get
		kdo "A5?", kdo_a5get
		kdo "A6?", kdo_a6get
		kdo "A7?", kdo_a7get

		kdo "B1?", kdo_b1get
		kdo "B2?", kdo_b2get
		kdo "B3?", kdo_b3get

		kdo "C0?", kdo_c0get
		kdo "C1?", kdo_c1get
		kdo "C2?", kdo_c2get
		kdo "C3?", kdo_c3get
		kdo "C4?", kdo_c4get
		kdo "C5?", kdo_c5get
		kdo "C6?", kdo_c6get
		kdo "C7?", kdo_c7get

		kdo "E0?", kdo_e0get
		kdo "E1?", kdo_e1get
		kdo "E2?", kdo_e2get
		kdo "E3?", kdo_e3get
		kdo "E4?", kdo_e4get
		kdo "E5?", kdo_e5get
		
		; Portein/ausgabe mit Quittierung	
		kdo "AH=", kdo_ahset
		kdo "AH?", kdo_ahget
		kdo "AS=", kdo_asset
		kdo "AS?", kdo_asget

		; Ereigniszhlen		
		kdo "Z=", kdo_zset
		kdo "Z?", kdo_zget
		
		; Impulserzeugung
		kdo "I=", kdo_iset
		
		; Frequenzerzeugung
		kdo "P=", kdo_pset
		kdo "F=", kdo_fset
		
		; Zeitmessen
		kdo "T=", kdo_tset
		kdo "T?", kdo_tget

		; A/D-Wandler ADC0808
		kdo "AD?", kdo_ADget
		kdo "AD0?", kdo_AD0get
		kdo "AD1?", kdo_AD1get
		kdo "AD2?", kdo_AD2get
		kdo "AD3?", kdo_AD3get

		; Multiplexen
		kdo "M=", kdo_Mset

		kdo "AM0?", kdo_AM0get
		kdo "AM1?", kdo_AM1get
		kdo "AM2?", kdo_AM2get
		kdo "AM3?", kdo_AM3get
		kdo "AM4?", kdo_AM4get
		kdo "AM5?", kdo_AM5get
		kdo "AM6?", kdo_AM6get
		kdo "AM7?", kdo_AM7get

		kdo "CM0?", kdo_CM0get
		kdo "CM1?", kdo_CM1get
		kdo "CM2?", kdo_CM2get
		kdo "CM3?", kdo_CM3get
		kdo "CM4?", kdo_CM4get
		kdo "CM5?", kdo_CM5get
		kdo "CM6?", kdo_CM6get
		kdo "CM7?", kdo_CM7get

		kdo "DM0=", kdo_DM0set
		kdo "DM1=", kdo_DM1set
		kdo "DM2=", kdo_DM2set
		kdo "DM3=", kdo_DM3set
		kdo "DM4=", kdo_DM4set
		kdo "DM5=", kdo_DM5set
		kdo "DM6=", kdo_DM6set
		kdo "DM7=", kdo_DM7set

		; Schrittmotorbetrieb
		kdo "S0=", kdo_S0set
		kdo "S1=", kdo_S1set
		kdo "S2=", kdo_S2set
		kdo "S3=", kdo_S3set

		kdo "SP=", kdo_SPset

		kdo "S0?", kdo_S0get
		kdo "S1?", kdo_S1get
		kdo "S2?", kdo_S2get
		kdo "S3?", kdo_S3get

		; Gleichstrommotorsteuerung
		kdo "DC=", kdo_DCset

		;frei fr zwei eigene Kdos
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
		db	 0
kdotab_end

;-----------------------------------------
;
;-----------------------------------------

; zu init
sub_1A92:	ld	R11, #21h
		clr	R4
loc_1A96:	ei
		clr	irq		; Interrupt request register
loc_1A99:	tm	irq, #8		; Interrupt request register
		jr	NZ, loc_1AAE
		cp	49h, #0
		jr	Z, loc_1A99
		ld	R3, 4Ah
		clr	R2
		clr	49h
		call	sub_1B4B
		jr	loc_1A99
;
loc_1AAE:	di
		ld	R3, sio		; Serial I/O
		and	R3, #7Fh
		cp	R3, #20h
		jr	Z, loc_1A96
		cp	R3, #1Bh	; ESC
		jr	Z, loc_1AD1
		ld	@R11, R3
		cp	R3, #0Dh	; ENTER
		jr	Z, loc_1ACF
		inc	R11
		cp	R11, #30h
		jr	Z, loc_1ACE
		inc	R4
		jr	loc_1A96
loc_1ACE:	scf
loc_1ACF:	ei
		ret
;
loc_1AD1:	pop	R3
		pop	R3
		ei
		ret

		db 0FFh


;-----------------------------------------
; Kommando in Tabelle suchen
;-----------------------------------------

searchkdo:	ld	R8, #18h	; hi(kdotab)
		ld	R9, #78h	; lo(kdotab)
loc_1ADC:	clr	R10
		ld	R11, #21h
loc_1AE0:	ld	R3, @R11	; Zeichen holen
		inc	R11		; Zeiger auf nchstes Zeichen
		cp	R3, #0Dh	; ENTER?
		jr	Z, loc_1B12	; dann Fehler
		ldc	R5, @RR8	; kdotabelle durchsuchen
		and	R5, #7Fh	; bit 7	lschen
		incw	RR8
		cp	R3, R5
		jr	NZ, loc_1B01	; wenn nicht gleich, mit nchstem Kdo in Tab. vergleichen
		cp	R3, #3Dh	; '='
		jr	Z, kdo_set
		cp	R3, #3Fh	; '?'
		jr	Z, kdo_get
		jr	loc_1AE0	; nchstes Zeichen

;nchstes Kdo in Liste ermitteln
loc_1AFF:	incw	RR8
loc_1B01:	cp	R8, #hi(kdotab_end)
		jr	LT, loc_1B0B
		cp	R9, #lo(kdotab_end)
		jr	UGT, loc_1B12	; Ende erreicht -> Fehler
loc_1B0B:	ldc	R5, @RR8
		inc	R5
		jr	PL, loc_1AFF
		jr	loc_1ADC
loc_1B12:	scf			; Fehler
		ret

;-----------------------------------------
; '=' (set) - Kommando
;-----------------------------------------

kdo_set:	ld	R0, #0FFh
		cp	@R11, #2Dh
		jr	NZ, loc_1B24
		inc	R11
		call	sub_153F
		call	61Ch
		jr	loc_1B2C
loc_1B24:	call	sub_153F
		cp	R8, #0FFh
		jr	Z, loc_1B12
loc_1B2C:	call	unk_E
		jr	loc_1B39

;-----------------------------------------
; '?' (get) - Kommando
;-----------------------------------------

kdo_get:	ld	R2, #lo(sub_1B4B)	; auf Stack legen
		push	R2
		ld	R2, #hi(sub_1B4B)
		push	R2
;		
loc_1B39:	ld	R5, #1
		ldc	R6, @RR8
		incw	RR8
		ldc	R7, @RR8
		rcf
		rrc	R6
		jr	NC, loc_1B49
		or	R7, #80h
loc_1B49:	jp	@RR6

;
sub_1B4B:	call	26Eh
		call	sub_1547
sub_1B51:	ld	R3, #0Dh	; ENTER
		call	putc		; Zeichen ausgeben
		ret

; ???
loc_1B57:	cp	49h, #0
		jr	Z, loc_1B57
		ld	R3, 4Ah
		clr	R2
		clr	49h
		ret


;-----------------------------------------
;Kommandomodus Init.
;-----------------------------------------

loc_1B63:	srp	#30h		; Registerzeiger auf Gruppe 4
		ld	R15, #80h
		ld	46h, #0FFh
		ld	p3m, #40h	; Port 3 mode
		clr	R12
		clr	R3
		call	sub_1D58
		ld	R5, #8
loc_1B76:	ld	4Ah(R5), R3
		djnz	R5, loc_1B76
		ld	R13, R12
		ld	R14, R12
		ld	tmr, #2		; Timer	mode
		ld	p2m, 46h	; Port 2 mode
		ld	pre1, #12h	; T1 prescaler
		ld	ipr, #8		; Interrupt priority register
		ld	>p2, R12	; Port 2
		ld	>p3, R13	; Port 3
		ld	R6, #50h
		ldc	@RR6, R14
		clr	48h		; Modus 0
		clr	49h
		call	sub_1B51
loc_1B9A:	call	sub_1A92
		jr	C, loc_1BA6
		call	searchkdo	; Kommando suchen
		jr	C, loc_1BA6
		jr	loc_1B9A
loc_1BA6:	nop
		jr	loc_1B9A



;--- bis hier kann der EPROM berschrieben werden (S. 199)


;-----------------------------------------
; G=
;-----------------------------------------

kdo_gset:	jp	@RR2


;-----------------------------------------

; zu kdo_fset
sub_1BAB:	dec	R15
		ld	@R15, R0
		dec	R15
		ld	@R15, R1
		ret

;-----------------------------------------
; IRQ 5
;-----------------------------------------

loc_1BB4:	ld	40h, R0
		ld	41h, R1
		ld	42h, R2
		ld	43h, R3
		ld	44h, R4
		ld	45h, R5
		ld	R2, 48h		; Modus merken
		djnz	R2, loc_1BCB
		inc	47h
		clr	t1		; Timer/counter	1
		jp	loc_1C81
;
loc_1BCB:	djnz	R2, loc_1BD7
		inc	47h
		clr	t1		; Timer/counter	1
		ld	tmr, #1Eh	; Timer	mode
		jp	loc_1C84
;
loc_1BD7:	djnz	R2, loc_1C1E
		ld	>p2, #0FFh		; Port 2
		ld	R3, 47h
		ld	R2, R3
		and	R3, #7
		jr	Z, loc_1BE9
		dec	R3
		jr	loc_1BF0
;
loc_1BE9:	swap	R2
		and	R2, #7
		ld	R3, R2
loc_1BF0:	ld	R0, 53h(R3)
		ld	R4, #60h
		ldc	@RR4, R0
		and	47h, #0F8h
		add	47h, R3
		ld	R1, R3
		inc	R1
		ld	R5, #7Fh
loc_1C02:	rl	R5
		djnz	R1, loc_1C02
		ld	>p2, R5		; Port 2
		ld	R4, #50h
		ldc	R0, @RR4
		ld	5Bh(R3), R0
		ld	R0, >p2		; Port 2
		ld	63h(R3), R0
		clr	t1		; Timer/counter	1
		ld	tmr, #0Eh	; Timer	mode
		clr	t1		; Timer/counter	1
		jp	loc_1C81
;
loc_1C1E:	djnz	R2, loc_1C58
		ld	R2, 3Eh
		and	R2, #55h
		ld	R4, #60h
		ldc	@RR4, R2
		ld	R5, #8
		ld	R3, #80h
loc_1C2D:	ld	R0, 49h(R5)
		ld	R1, 4Ah(R5)
		cp	R0, #0
		jr	NZ, loc_1C3D
		cp	R1, #0
		jr	Z, loc_1C4D
;
loc_1C3D:	xor	R2, R3
		ldc	@RR4, R2
		decw	RR0
		ld	4Ah(R5), R1
		ld	49h(R5), R0
		xor	R2, R3
		ldc	@RR4, R2
loc_1C4D:	rr	R3
		rr	R3
		dec	R5
		djnz	R5, loc_1C2D
		jp	loc_1C81
;
loc_1C58:	djnz	R2, loc_1C6F
		ld	R2, 47h
		com	R2
		inc	R2
		ld	R3, 3Dh
		and	R3, #0BFh
		ld	3Dh, R3
		ld	>p3, R3		; Port 3
		ld	t1, R2		; Timer/counter	1
		ld	48h, #6		; Modus 6
		jr	loc_1C81
;
loc_1C6F:	djnz	R2, loc_1C84
		ld	R2, 47h
		ld	R3, 3Dh
		or	R3, #40h
		ld	3Dh, R3
		ld	>p3, R3		; Port 3
		ld	t1, R2		; Timer/counter	1
		ld	48h, #5		; Modus 5
loc_1C81:	ld	tmr, #0Eh	; Timer	mode
loc_1C84:	ld	R0, 40h
		ld	R1, 41h
		ld	R2, 42h
		ld	R3, 43h
		ld	R4, 44h
		ld	R5, 45h
irqret:		iret

		nop

;==============================================================================
; Kommando-Routinen
;==============================================================================

;-----------------------------------------
; A=
;-----------------------------------------


kdo_aset:	ld	p3m, #40h	; Port 3 mode
		call	sub_1EAE
		clr	46h
		clr	p2m		; Port 2 mode
		ld	3Ch, R3
		ld	>p2, R3		; Port 2
		ret

;-----------------------------------------
; B=
;-----------------------------------------


kdo_bset:	ld	p3m, #40h	; Port 3 mode
		and	tmr, #3Fh	; Timer	mode
		and	48h, #3
		nop
		ld	3Dh, R3
		ld	>p3, R3		; Port 3
		ret

;-----------------------------------------
; D=
;-----------------------------------------


kdo_dset:	ld	R4, #60h	; Adr. %60xx
		ld	3Eh, R3
		ldc	@RR4, R3
		jp	sub_1D58

;-----------------------------------------
; A?
;-----------------------------------------


kdo_aget:	ld	p3m, #40h	; Port 3 mode
		call	sub_1EAE
		ld	46h, #0FFh
		ld	p2m, 46h	; Port 2 mode
		ld	R3, >p2		; Port 2
		jr	loc_1CDD

;-----------------------------------------
; B?
;-----------------------------------------


kdo_bget:	ld	p3m, #40h	; Port 3 mode
		ld	pre1, #12h	; T1 prescaler
		ld	R3, >p3		; Port 3
		jr	loc_1CDD

;-----------------------------------------
; C?
;-----------------------------------------


kdo_cget:	ld	R4, #50h	; Adr. %50xx
		ldc	R3, @RR4
		jr	loc_1CDD

;-----------------------------------------
; E?
;-----------------------------------------


kdo_eget:	ld	R4, #70h	; Adr. %70xx
		ldc	R3, @RR4
loc_1CDD:	clr	R2
		ret

;-----------------------------------------
; Ax=
;-----------------------------------------


kdo_a7set:	rl	R5
kdo_a6set:	rl	R5
kdo_a5set:	rl	R5
kdo_a4set:	rl	R5
kdo_a3set:	rl	R5
kdo_a2set:	rl	R5
kdo_a1set:	rl	R5
kdo_a0set:	com	R5
		call	sub_1EAE
		and	46h, R5
		ld	p2m, 46h	; Port 2 mode
		and	3Ch, R5
		or	R2, R3
		jr	Z, loc_1D05
		com	R5
		or	3Ch, R5
loc_1D05:	ld	>p2, 3Ch	; Port 2
		ret

;-----------------------------------------
; Bx=
;-----------------------------------------


kdo_b6set:	rl	R5
kdo_b5set:	rl	R5
kdo_b4set:	rl	R5
		rl	R5
		rl	R5
		rl	R5
		cp	R5, #40h
		jr	NZ, loc_1D24
		ld	p3m, #40h	; Port 3 mode
		and	tmr, #3Fh	; Timer	mode
		and	48h, #3
		nop
loc_1D24:	com	R5
		and	3Dh, R5
		or	R2, R3
		jr	Z, loc_1D32
		com	R5
		or	3Dh, R5
loc_1D32:	ld	>p3, 3Dh	; Port 3
		ret

;-----------------------------------------
; Dx=
;-----------------------------------------

kdo_d7set:	rl	R5
kdo_d6set:	rl	R5
kdo_d5set:	rl	R5
kdo_d4set:	rl	R5
kdo_d3set:	rl	R5
kdo_d2set:	rl	R5
kdo_d1set:	rl	R5
kdo_d0set:	com	R5
		and	3Eh, R5
		or	R2, R3
		jr	Z, loc_1D52
		com	R5
		or	3Eh, R5
loc_1D52:	ld	R3, 3Eh
		ld	R4, #60h	; Adr. %60xx
		ldc	@RR4, R3
sub_1D58:	ld	R5, #8
loc_1D5A:	ld	52h(R5), R3
		djnz	R5, loc_1D5A
		ret

;-----------------------------------------
; Ax?
;-----------------------------------------

kdo_a7get:	rl	R5
kdo_a6get:	rl	R5
kdo_a5get:	rl	R5
kdo_a4get:	rl	R5
kdo_a3get:	rl	R5
kdo_a2get:	rl	R5
kdo_a1get:	rl	R5
kdo_a0get:	or	46h, R5
		call	sub_1EAE
		ld	p2m, 46h	; Port 2 mode
		ld	R3, >p2		; Port 2
		jr	loc_1DB2

;-----------------------------------------
; Bx?
;-----------------------------------------

kdo_b3get:	rl	R5
kdo_b2get:	rl	R5
kdo_b1get:	rl	R5
		cp	R5, #2
		jr	NZ, loc_1D8C
		ld	p3m, #40h	; Port 3 mode
		ld	pre1, #12h	; T1 prescaler
loc_1D8C:	ld	R3, >p3		; Port 3
		jr	loc_1DB2

;-----------------------------------------
; Cx?
;-----------------------------------------

kdo_c7get:	rl	R5
kdo_c6get:	rl	R5
kdo_c5get:	rl	R5
kdo_c4get:	rl	R5
kdo_c3get:	rl	R5
kdo_c2get:	rl	R5
kdo_c1get:	rl	R5
kdo_c0get:	ld	R4, #50h
		ldc	R3, @RR4	; Wert von Adr. %50xx lesen
		jr	loc_1DB2

;-----------------------------------------
; Ex?
;-----------------------------------------

kdo_e5get:	rl	R5
kdo_e4get:	rl	R5
kdo_e3get:	rl	R5
kdo_e2get:	rl	R5
kdo_e1get:	rl	R5
kdo_e0get:	ld	R4, #70h	; Wert von Adr. %70xx lesen
		ldc	R3, @RR4
loc_1DB2:	and	R3, R5		; Bit maskieren
		jr	Z, loc_1DB8
		ld	R3, #1		; 0 oder 1 zurckgeben
loc_1DB8:	clr	R2
		ret

;-----------------------------------------
; Z=
;-----------------------------------------

kdo_zset:	ld	48h, #1		; Modus 1 Ereigniszhlen
		call	sub_1DC9
		ret

;-----------------------------------------
; T=
;-----------------------------------------

kdo_tset:	ld	48h, #2		; Modus 2 Zeitmessen
		call	sub_1DC9
		ret
;
sub_1DC9:	ld	imr, #0A0h	; Interrupt mask register
		rcf
		rlc	R3
		rcf
		rlc	R3
		ld	pre1, R3	; T1 prescaler
		clr	47h
		clr	t1		; Timer/counter	1
		ld	p3m, #40h	; Port 3 mode
		ld	R3, 48h
		djnz	R3, loc_1DE3
		ld	tmr, #0Eh	; Timer	mode
		ret
;
loc_1DE3:	ld	tmr, #1Eh	; Timer	mode
		ret

;-----------------------------------------
; T?, Z?
;-----------------------------------------

kdo_tget:
kdo_zget:	ld	R3, t1		; Timer/counter	1
		com	R3
		inc	R3
		ld	R2, 47h
		jp	loc_1FFC

;-----------------------------------------
; F=
;-----------------------------------------

kdo_fset:	push	R6
		push	R7
		push	R8
		clr	R6
		clr	R7
		ld	R0, #0E1h
		clr	R1
		ld	R8, #4
loc_1E01:	call	sub_1BAB
		call	26Eh
		call	2D6h
		call	5FDh
		rl	R7
		rlc	R6
		add	R7, R5
		add	R6, R4
		djnz	R8, loc_1E01
		ld	R2, R6
		ld	R3, R7
		pop	R8
		pop	R7
		pop	R6

;-----------------------------------------
; P=
;-----------------------------------------

kdo_pset:	ld	R4, #3
		jr	loc_1E27

;-----------------------------------------
; I=
;-----------------------------------------

kdo_iset:	ld	R4, #2
loc_1E27:	ld	p3m, #40h	; Port 3 mode
		ld	imr, #80h	; Interrupt mask register
		ld	R5, #1
loc_1E2F:	inc	R2
		djnz	R2, loc_1E4E
		inc	R3
		djnz	R3, loc_1E3D
loc_1E35:	clr	pre1		; T1 prescaler
		clr	t1		; Timer/counter	1
		ld	tmr, #2		; Timer	mode
		ret
;
loc_1E3D:	rl	R5
		rl	R5
		and	R5, #0FCh
		add	R5, R4
		ld	pre1, R5	; T1 prescaler
		ld	t1, R3		; Timer/counter	1
		ld	tmr, #8Eh	; Timer	mode
		ret
;
loc_1E4E:	rcf
		rrc	R2
		rrc	R3
		rl	R5
		cp	R5, #80h
		jr	Z, loc_1E35
		jr	loc_1E2F

;-----------------------------------------
; AMx?
;-----------------------------------------

kdo_am7get:	inc	R5
kdo_am6get:	inc	R5
kdo_am5get:	inc	R5
kdo_am4get:	inc	R5
kdo_am3get:	inc	R5
kdo_am2get:	inc	R5
kdo_am1get:	inc	R5
kdo_am0get:	ld	R3, 62h(R5)
		jr	loc_1E72

;-----------------------------------------
; CMx?
;-----------------------------------------

kdo_cm7get:	inc	R5
kdo_cm6get:	inc	R5
kdo_cm5get:	inc	R5
kdo_cm4get:	inc	R5
kdo_cm3get:	inc	R5
kdo_cm2get:	inc	R5
kdo_cm1get:	inc	R5
kdo_cm0get:	ld	R3, 5Ah(R5)
loc_1E72:	ld	tmr, #0Ah	; Timer	mode
		clr	R2
		ret

;-----------------------------------------
; DMx=
;-----------------------------------------

kdo_dm7set:	inc	R5
kdo_dm6set:	inc	R5
kdo_dm5set:	inc	R5
kdo_dm4set:	inc	R5
kdo_dm3set:	inc	R5
kdo_dm2set:	inc	R5
kdo_dm1set:	inc	R5
kdo_dm0set:	ld	tmr, #0Ah	; Timer	mode
		ld	52h(R5), R3
		ret

;-----------------------------------------
; M=
;-----------------------------------------

kdo_mset:	and	R3, #7
		jr	Z, sub_1EAE
		ld	R2, R3
		swap	R2
		or	R2, R3
		ld	47h, R2
		ld	R2, #0FFh
		inc	R3
loc_1E96:	rcf
		rlc	R2
		djnz	R3, loc_1E96
		ld	46h, R2
		ld	p2m, R2		; Port 2 mode
		ld	imr, #0A0h	; Interrupt mask register
		ld	pre1, #12h	; T1 prescaler
		clr	t1		; Timer/counter	1
		ld	48h, #3		; Modus 3 "Multiplexen" merken
		ld	tmr, #0Eh	; Timer	mode
locret_1EAD:	ret

;-----------------------------------------

sub_1EAE:	cp	48h, #3		; Modus 3 "Multiplexen" ?
		jr	NZ, locret_1EAD
		jp	loc_1E35

;-----------------------------------------
; AH=
;-----------------------------------------

kdo_ahset:	clr	46h
		clr	p2m		; Port 2 mode
		ld	3Ch, R3
		or	3Dh, #40h
		ld	>p3, 3Dh	; Port 3
		ld	p3m, #60h	; Port 3 mode
		ld	imr, #84h	; Interrupt mask register
		ld	>p2, R3		; Port 2
		ret

;-----------------------------------------
; AH?
;-----------------------------------------

kdo_ahget:	ld	46h, #0FFh
		ld	p2m, 46h	; Port 2 mode
		or	3Dh, #40h
		ld	>p3, 3Dh	; Port 3
		ld	p3m, #60h	; Port 3 mode
		ld	imr, #84h	; Interrupt mask register
		pop	R4
		pop	R5
		cp	R4, #1Bh
		jr	Z, locret_1EEF
		cp	R5, #4Bh
		jr	Z, locret_1EEF
		push	R5
		push	R4
locret_1EEF:	ret


;-----------------------------------------
;IRQ 2
;-----------------------------------------

loc_1EF0:	ld	p3m, #40h	; Port 3 mode
		clr	imr		; Interrupt mask register
		cp	46h, #0
		jr	Z, loc_1F01
		ld	4Ah, >p2	; Port 2
		ld	49h, #0FFh
		iret
;
loc_1F01:	ld	4Ah, #1
		ld	49h, #0FFh
		iret


;-----------------------------------------
; Sx=
;-----------------------------------------

kdo_s3set:	inc	R5
		inc	R5
kdo_s2set:	inc	R5
		inc	R5
kdo_s1set:	inc	R5
		inc	R5
kdo_s0set:	clr	R4
		cp	R2, #0
		jr	PL, loc_1F1D
		com	R3
		com	R2
		incw	RR2
		ld	R4, #80h
loc_1F1D:	ld	R0, R5
		ld	R1, #7Fh
loc_1F21:	rl	R4
		rl	R1
		djnz	R0, loc_1F21
		ld	4Ah(R5), R2
		ld	4Bh(R5), R3
		ld	R0, 3Eh
		and	R0, #55h
		and	R0, R1
		or	R0, R4
		ld	48h, #4		; Modus 4 Schrittmotorbetrieb
		ld	3Eh, R0
		ld	R4, #60h
		ldc	@RR4, R0
		ld	R5, #8
loc_1F41:	ld	52h(R5), R0
		djnz	R5, loc_1F41
		ld	imr, #0A0h	; Interrupt mask register
		ld	pre1, 47h	; T1 prescaler
		clr	t1		; Timer/counter	1
		ld	tmr, #0Eh	; Timer	mode
		ret

;-----------------------------------------
; SP=
;-----------------------------------------


kdo_spset:	cp	R2, #0
		jr	NZ, loc_1F68
		rcf
		rlc	R3
		jr	C, loc_1F68
		rlc	R3
		jr	C, loc_1F68
loc_1F60:	or	R3, #2
		ld	pre1, R3	; T1 prescaler
		ld	47h, R3
		ret
;
loc_1F68:	clr	R3
		jr	loc_1F60


;-----------------------------------------
; Sx?
;-----------------------------------------

kdo_s3get:	inc	R5
		inc	R5
kdo_s2get:	inc	R5
		inc	R5
kdo_s1get:	inc	R5
		inc	R5
kdo_s0get:	ld	R2, 4Ah(R5)
		ld	R3, 4Bh(R5)
		ret

;-----------------------------------------
; AS=
;-----------------------------------------

kdo_asset:	call	kdo_aset
		and	3Dh, #0EFh
		ld	>p3, 3Dh	; Port 3
		or	3Dh, #10h
		ld	>p3, 3Dh	; Port 3
		ret

;-----------------------------------------
; AS?
;-----------------------------------------

kdo_asget:	call	kdo_aget
		and	3Dh, #0EFh
		ld	>p3, 3Dh	; Port 3
		ld	R3, >p2		; Port 2
		or	3Dh, #10h
		ld	>p3, 3Dh	; Port 3
loc_1F9A:	clr	R2
		ret

		nop

;-----------------------------------------
; ADx?
;-----------------------------------------

kdo_ad3get:	inc	R5
kdo_ad2get:	inc	R5
kdo_ad1get:	inc	R5
kdo_ad0get:	dec	R5
		rl	R5
		swap	R5
		ld	3Dh, R5

;-----------------------------------------
; ADx=
;-----------------------------------------

kdo_adget:	ld	R3, 3Dh
		and	R3, #0EFh
		call	kdo_bset
		or	R3, #10h
		ld	>p3, R3		; Port 3
		and	R3, #0EFh
		ld	>p3, R3		; Port 3
		ld	3Dh, R3
		ld	R4, #50h
loc_1FBF:	tm	>p3, #8		; Port 3
		jr	Z, loc_1FBF
		ldc	R3, @RR4
		jr	loc_1F9A

;-----------------------------------------
; DC=
;-----------------------------------------

kdo_dcset:	ld	47h, R3
		cp	R3, #0
		jr	Z, loc_1FE8
		cp	48h, #5		; Modus 5 ?
		jr	Z, loc_1FFC
		cp	48h, #6		; Modus 6 ?
		jr	Z, loc_1FFC
		ld	imr, #0A0h	; Interrupt mask register
		ld	pre1, #2	; T1 prescaler
		ld	t1, R3		; Timer/counter	1
		ld	48h, #6		; Modus 6
		ld	tmr, #0Eh	; Timer	mode
		ret
;
loc_1FE8:	ld	imr, #80h	; Interrupt mask register
		clr	t1		; Timer/counter	1
		clr	48h		; Modus 0
		ld	R3, 3Dh
		and	R3, #0BFh
		ld	3Dh, R3
		ld	>p3, R3		; Port 3
		ld	tmr, #2		; Timer	mode
		ret
;
loc_1FFC:	or	tmr, #0Ah	; Timer	mode
		ret


;-----------------------------------------

		end

- im Buch sind die Adr. fr die ADx-Kommandos falsch angegeben.
- es gibt einige unklare/ungenutzte Bereiche und freie Bytes.
- vermutlich musste wg. der Festlegung der Adressen, wie sie im Buch stehen, 
  der EPROM gepatcht werden und wurde nicht komplett neu kompiliert.
